aboutsummaryrefslogtreecommitdiff
path: root/gen
diff options
context:
space:
mode:
Diffstat (limited to 'gen')
-rwxr-xr-xgen/data-files1
-rwxr-xr-xgen/prop/hst55
2 files changed, 56 insertions, 0 deletions
diff --git a/gen/data-files b/gen/data-files
index 156e4d5..1499eea 100755
--- a/gen/data-files
+++ b/gen/data-files
@@ -23,6 +23,7 @@ extracted/DerivedEastAsianWidth
extracted/DerivedLineBreak
extracted/DerivedNumericType
extracted/DerivedNumericValues
+HangulSyllableType
PropList
Scripts
SpecialCasing
diff --git a/gen/prop/hst b/gen/prop/hst
new file mode 100755
index 0000000..f1af5df
--- /dev/null
+++ b/gen/prop/hst
@@ -0,0 +1,55 @@
+#!/bin/sh
+
+set -e
+cd "${0%/*}/../.."
+exec >lib/unicode/prop/uprop_get_hst.c
+
+gawk '
+BEGIN {
+ FS = "( *#.*| +; +)"
+
+ print "/* This file is autogenerated by gen/prop/hst; DO NOT EDIT. */"
+ print ""
+ print "#include \"_bsearch.h\""
+ print "#include \"rune.h\""
+ print "#include \"unicode/prop.h\""
+ print ""
+}
+
+/^[^#]/ {
+ n = split($1, a, /\.\./)
+ lo = strtonum("0X" a[1])
+ hi = strtonum("0X" a[n])
+
+ for (i = lo; i <= hi; i++) {
+ gsub(/^; /, "", $2)
+ props[i] = "HST_" toupper($2)
+ }
+}
+
+END {
+ print "static const struct {"
+ print "\trune lo, hi;"
+ print "\tenum uprop_hst val;"
+ print "} lookup[] = {"
+
+ for (i = 0x1100; i <= 0x10FFFF; i++) {
+ if (!props[i])
+ continue
+ lo = i
+ while (props[lo] == props[i + 1])
+ i++
+ printf "\t{RUNE_C(0x%06X), RUNE_C(0x%06X), %s},\n", lo, i, props[i]
+ }
+
+ print "};"
+ print ""
+ print "_MLIB_DEFINE_BSEARCH(enum uprop_hst, lookup, HST_NA)"
+ print ""
+ print "enum uprop_hst"
+ print "uprop_get_hst(rune ch)"
+ print "{"
+ print "\treturn ch < RUNE_C(0x1100) ? HST_NA : mlib_lookup(ch);"
+ print "}"
+}
+' data/HangulSyllableType | sed 's/\s*$//'